package io.renren.modules.sys.controller;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletResponse;

import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;

import io.renren.common.annotation.LogOperation;
import io.renren.common.constant.Constant;
import io.renren.common.page.PageData;
import io.renren.common.utils.ExcelUtils;
import io.renren.common.utils.Result;
import io.renren.common.validator.AssertUtils;
import io.renren.common.validator.ValidatorUtils;
import io.renren.common.validator.group.AddGroup;
import io.renren.common.validator.group.DefaultGroup;
import io.renren.common.validator.group.UpdateGroup;
import io.renren.modules.security.controller.AbstractController;
import io.renren.modules.sys.dto.OperationsDTO;
import io.renren.modules.sys.entity.OperationsEntity;
import io.renren.modules.sys.entity.SysUserEntity;
import io.renren.modules.sys.excel.OperationsExcel;
import io.renren.modules.sys.service.OperationsService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import springfox.documentation.annotations.ApiIgnore;


/**
 * 运营机构表
 *
 * @author Mark sunlightcs@gmail.com
 * @since 1.0.0 2022-05-29
 */
@RestController
@RequestMapping("sys/operations")
@Api(tags="运营机构表")
public class OperationsController extends AbstractController{
    @Autowired
    private OperationsService operationsService;

    @GetMapping("page")
    @ApiOperation("分页")
    @ApiImplicitParams({
        @ApiImplicitParam(name = Constant.PAGE, value = "当前页码，从1开始", paramType = "query", required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.LIMIT, value = "每页显示记录数", paramType = "query",required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.ORDER_FIELD, value = "排序字段", paramType = "query", dataType="String") ,
        @ApiImplicitParam(name = Constant.ORDER, value = "排序方式，可选值(asc、desc)", paramType = "query", dataType="String")
    })
    @RequiresPermissions("sys:operations:page")
    public Result<PageData<OperationsDTO>> page(@ApiIgnore @RequestParam Map<String, Object> params){
        PageData<OperationsDTO> page = operationsService.page(params);
        for (OperationsDTO dto : page.getList()) {
        	SysUserEntity creator = sysUserService.selectById(dto.getCreator());
        	if(null != creator) {
        		dto.setCreatorName(creator.getRealName());
        	}
        	
        	SysUserEntity update = sysUserService.selectById(dto.getUpdateBy());
        	if(null != update) {
        		dto.setUpdateName(update.getRealName());
        	}
        	
		}
        return new Result<PageData<OperationsDTO>>().ok(page);
    }

    @GetMapping("list")
    @ApiOperation("列表")
    public Result<List<OperationsDTO>> get(){
        List<OperationsDTO> list = operationsService.list(new HashMap<>());

        return new Result<List<OperationsDTO>>().ok(list);
    }
    
    @GetMapping("listAll")
    @ApiOperation("所有数据")
    public Result<List<OperationsEntity>> listAll(){
        return new Result<List<OperationsEntity>>().ok(operationsService.listAll());
    }

    @GetMapping("{id}")
    @ApiOperation("信息")
    @RequiresPermissions("sys:operations:info")
    public Result<OperationsDTO> get(@PathVariable("id") Long id){
        OperationsDTO data = operationsService.get(id);

        return new Result<OperationsDTO>().ok(data);
    }

    @PostMapping
    @ApiOperation("保存")
    @LogOperation("保存")
    @RequiresPermissions("sys:operations:save")
    public Result save(@RequestBody OperationsDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);
        operationsService.save(dto);

        return new Result();
    }

    @PutMapping
    @ApiOperation("修改")
    @LogOperation("修改")
    @RequiresPermissions("sys:operations:update")
    public Result update(@RequestBody OperationsDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);
        dto.setUpdateBy(getUserId());
        dto.setUpdateTime(new Date());
        operationsService.update(dto);

        return new Result();
    }

    @DeleteMapping
    @ApiOperation("删除")
    @LogOperation("删除")
    @RequiresPermissions("sys:operations:delete")
    public Result delete(@RequestBody Long[] ids){
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");
        
        OperationsEntity entity = new OperationsEntity();
        entity.setStatus(Constant.Status.DISABLE.getValue());
        entity.setUpdateBy(getUserId());
        entity.setDeleteTime(new Date());
        operationsService.update(entity, new UpdateWrapper<OperationsEntity>().in("id", ids));
        //operationsService.delete(ids);
        return new Result();
    }

    @GetMapping("export")
    @ApiOperation("导出")
    @LogOperation("导出")
    @RequiresPermissions("sys:operations:export")
    public void export(@ApiIgnore @RequestParam Map<String, Object> params, HttpServletResponse response) throws Exception {
        List<OperationsDTO> list = operationsService.list(params);

        ExcelUtils.exportExcelToTarget(response, null, list, OperationsExcel.class);
    }

}